
{*******************************************************}
{                                                       }
{       Turbo Pascal Version 7.0                        }
{       Multi-Sprites Editor Unit                       }
{                                                       }
{       Copyright (c) 1994,95 by Solar Designer         }
{                                                       }
{*******************************************************}

unit Hints;
interface
uses
   GMenus, GApp,
   StdVideo;

const
   hcPressAnyKey = $EFFF;
   cmAnyKey =      7000;

   hcScaleDown =   $F100;
   hcScaleUp =     $F101;

   hcPaletteLoad = $F110;
   hcPaletteSave = $F111;
   hcPaletteStd =  $F112;

   hcShowUsed =    $F118;

   hcSetColor =    $F120;
   hcGetColor =    $F121;
   hcFillArea =    $F122;
   hcReplace =     $F123;

   hcRectangle =   $F124;
   hcBar =         $F125;
   hcLine =        $F126;

   hcFlipX =       $F128;
   hcFlipY =       $F129;

   hcSmooth =      $F12A;
   hcEdge =        $F12B;
   hcGray =        $F12C;

   hcScale =       $F12E;

   hcClipboard =   $F12F;

   hcNextImage =   $F138;
   hcPrevImage =   $F139;
   hcInsImage =    $F13A;
   hcDelImage =    $F13B;

   hcInfo =        $F130;
   hcConvert =     $F131;

   hcSaveOpts =    $F140;

   hcFileMenu =    $F200;
   hcEditMenu =    $F201;
   hcPaletteMenu = $F202;
   hcWindowMenu =  $F203;
   hcVideoMenu =   $F204;

   hcWait =        $F300;
   hcWaitCalc =    $F400;

   hcLow =         $F280;
   hcModeX =       $F281;
   hcSVGA =        $F282;

   hcEditMode =    $F180;
   hcEditBlock =   $F181;
   hcEditEffects = $F182;
   hcEditImages =  $F183;

type
   PHintStatusLine = ^THintStatusLine;
   THintStatusLine =
   object(TStatusLine)

      function  Hint(AHelpCtx          :Word)              :THintStr; virtual;

   end;

implementation

function  THintStatusLine.Hint;
var
   Value           :String[5];
begin
   case AHelpCtx of

      hcFileMenu:       Hint:='File management commands';
      hcEditMenu:       Hint:='Editing commands';
      hcPaletteMenu:    Hint:='Palette operations';
      hcWindowMenu:     Hint:='Arrange windows';
      hcVideoMenu:      Hint:='Change video mode';

      hcAbout:          Hint:='Show version and copyright information';
      hcInfo:           Hint:='Show status information';
      hcConvert:        Hint:='Convert the active image';

      hcNew:            Hint:='Create a new image in a new window';
      hcOpen:           Hint:='Select and load an image';
      hcSave:           Hint:='Save the active image';
      hcSaveAs:         Hint:='Save under a different name';
      hcSaveAll:        Hint:='Save all modified images';

      hcChangeDir:      Hint:='Choose a new default directory';
      hcDOSShell:       Hint:='Temporarily exit to DOS';
      hcExit:           Hint:='Exit the editor';

      hcUndo:           Hint:='Undo the previous editor operation';

      hcEditMode:       Hint:='Change the editor mode';
      hcSetColor:       Hint:='Normal editor mode';
      hcGetColor:       Hint:='Get color from the image';
      hcFillArea:       Hint:='Fill a bounded region';
      hcReplace:        Hint:='Replace color in a rectangular area';

      hcRectangle:      Hint:='Draw a rectangle';
      hcBar:            Hint:='Draw a bar';
      hcLine:           Hint:='Draw a line';

      hcEditBlock:      Hint:='Block operations';
      hcCopy:           Hint:='Copy a block to the Clipboard';
      hcPaste:          Hint:='Insert block from the Clipboard';
      hcClipboard:      Hint:='Open the Clipboard window';

      hcEditEffects:    Hint:='Special effects';
      hcFlipX:          Hint:='Flip the image horizontally';
      hcFlipY:          Hint:='Flip the image vertically';
      hcSmooth:         Hint:='Smooth the image';
      hcEdge:           Hint:='Highlight edges in the image';
      hcGray:           Hint:='Grayscale the image';
      hcScale:          Hint:='Scale the image to any size';

      hcEditImages:     Hint:='Multiple images operations';
      hcNextImage:      Hint:='Make the next image active';
      hcPrevImage:      Hint:='Make the previous image active';
      hcInsImage:       Hint:='Insert a new image';
      hcDelImage:       Hint:='Delete the current image';

      hcPaletteLoad:    Hint:='Load a RGB palette';
      hcPaletteSave:    Hint:='Save the current RGB palette';
      hcPaletteStd:     Hint:='Restore the standard palette';
      hcShowUsed:       Hint:='Show actually used colors';

      hcTile:           Hint:='Arrange windows by tiling';
      hcCascade:        Hint:='Arrange windows by cascading';
      hcCloseAll:       Hint:='Close all windows';
      hcRefresh:        Hint:='Redraw the screen';

      hcResize:         Hint:='Resize or move the active window';
      hcZoom:           Hint:='Enlarge or restore the active window';
      hcNext:           Hint:='Make the next window active';
      hcPrev:           Hint:='Make the previous window active';
      hcClose:          Hint:='Close the active window';

      hcScaleDown:      Hint:='Decrease the magnification';
      hcScaleUp:        Hint:='Increase the magnification';

      hcLow:            Hint:='Low resolution VGA modes';
      hcModeX:          Hint:='Extended VGA modes';
      hcSVGA:           Hint:='VESA, Trident & Realtek SVGA modes';

      hcVideoVGA:       Hint:='Standard VGA mode';
      hcVideoLowVGA:    Hint:='Low resolution VGA mode (fast)';

      hcVideoExtVGA:    Hint:='Extended VGA mode';
      hcVideoExtSVGA:   Hint:='Extended SVGA mode';

      hcVideoVESAHi:    Hint:='VESA SVGA, 512 Kb video RAM';
      hcVideoRTVGA:     Hint:='Realtek SVGA, 512 Kb video RAM';
      hcVideoTrident:   Hint:='Trident SVGA, 512 Kb video RAM';

      hcSaveOpts:       Hint:='Save the current video mode in file';

      hcWait:           Hint:='Please, wait ...';
      hcWaitCalc..hcWaitCalc+99:
      begin
         Str(AHelpCtx-hcWaitCalc, Value);
         Hint:='Calculating tables ('+Value+'% done) ...';
      end;

   else
      Hint := '';
   end;
end;

end.
