
{*******************************************************}
{                                                       }
{       Turbo Pascal Version 7.0                        }
{       Graphics Vision Unit                            }
{                                                       }
{       Copyright (c) 1994,95 by Solar Designer         }
{                                                       }
{*******************************************************}

unit GSaver;
interface
uses
   DOS,
   Events,
   GDrivers, GApp;

const
   SaverExt =      'SS';
   SaverMin =      1092;

type
   TSaverApp =
   object(TApplication)

      SaverName    :String[12];
      SaverStart,
      SaverTime    :LongInt;

      constructor Init(const Driver    :String;
                       Mode            :Word;
                       ASaverTime      :LongInt);

      procedure GetEvent(var Event     :TEvent); virtual;
      procedure Idle; virtual;
      procedure DosShell; virtual;
      procedure ActivateSaver;
   end;

implementation

var
   Timer           :LongInt absolute 0:$46C;

{ TSaverApp }

constructor TSaverApp.Init;
var
   Info            :SearchRec;
begin
   Inherited Init(Driver, Mode);

   FindFirst(GetPath+'*.'+SaverExt, Archive+ReadOnly, Info);
   if DosError=0 then SaverName:=Info.Name else SaverName:='';
   SaverStart:=Timer; SaverTime:=ASaverTime;
end;

procedure TSaverApp.GetEvent;
begin
   Inherited GetEvent(Event);

   if Event.What and (evMouse or evKeyboard)<>0 then SaverStart:=Timer;
end;

procedure TSaverApp.Idle;
begin
   Inherited Idle;

   if Timer<SaverStart then SaverStart:=Timer else
   if Timer-SaverStart>SaverTime then
   begin
      ActivateSaver;
      SaverStart:=Timer;
   end;
end;

procedure TSaverApp.DosShell;
begin
   Inherited DosShell;

   SaverStart:=Timer;
end;

procedure TSaverApp.ActivateSaver;
begin
   if SaverName='' then Exit;
   Exec(GetPath+SaverName, '');
end;

end.
